/*
 *   moo.h
 *
 *   Copyright (C) 2004-2007 by Yevgen Muntyan <muntyan@math.tamu.edu>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   See COPYING file that comes with this distribution.
 */

#ifndef __MOO_H__
#define __MOO_H__


#include <moo-config.h>

#include <mooedit/moocmdview.h>
#include <mooedit/moocommand.h>
#include <mooedit/mooedit.h>
#include <mooedit/mooedit-bookmarks.h>
#include <mooedit/mooedit-enums.h>
#include <mooedit/mooeditaction.h>
#include <mooedit/mooeditaction-factory.h>
#include <mooedit/mooeditconfig.h>
#include <mooedit/mooeditor.h>
#include <mooedit/mooeditprefs.h>
#include <mooedit/mootextsearch.h>
#include <mooedit/mooeditwindow.h>
#include <mooedit/mooindenter.h>
#include <mooedit/moolang.h>
#include <mooedit/moolangmgr.h>
#include <mooedit/moolinemark.h>
#include <mooedit/moolineview.h>
#include <mooedit/moooutputfilter.h>
#include <mooedit/mooplugin-macro.h>
#include <mooedit/mooplugin.h>
#include <mooedit/mootextbuffer.h>
#include <mooedit/mootextiter.h>
#include <mooedit/mootextstyle.h>
#include <mooedit/mootextstylescheme.h>
#include <mooedit/mootextview.h>
#include <mooedit/mooedit-script.h>
#include <mooedit/mooedit-enums.h>

#include <mooterm/mooterm.h>
#include <mooterm/mooterm-text.h>
#include <mooterm/mootermline.h>
#include <mooterm/mootermtag.h>
#include <mooterm/mootermbuffer.h>
#include <mooterm/mooterm-prefs.h>

#include <mooutils/mooaccelbutton.h>
#include <mooutils/mooaction.h>
#include <mooutils/mooactionbase.h>
#include <mooutils/mooactioncollection.h>
#include <mooutils/moobigpaned.h>
#include <mooutils/mooclosure.h>
#include <mooutils/moocombo.h>
#include <mooutils/moodialogs.h>
#include <mooutils/mooentry.h>
#include <mooutils/moofiledialog.h>
#include <mooutils/moofilewatch.h>
#include <mooutils/moofiltermgr.h>
#include <mooutils/mooglade.h>
#include <mooutils/moohistorycombo.h>
#include <mooutils/moohistorylist.h>
#include <mooutils/moomarkup.h>
#include <mooutils/moomenuaction.h>
#include <mooutils/moomenumgr.h>
#include <mooutils/moomenutoolbutton.h>
#include <mooutils/moonotebook.h>
#include <mooutils/moopaned.h>
#include <mooutils/mooprefs.h>
#include <mooutils/mooprefsdialog.h>
#include <mooutils/mooprefsdialogpage.h>
#include <mooutils/moopython.h>
#include <mooutils/moostock.h>
#include <mooutils/moouixml.h>
#include <mooutils/mooundo.h>
#include <mooutils/mooutils-fs.h>
#include <mooutils/mooutils-gobject.h>
#include <mooutils/mooutils-misc.h>
#include <mooutils/moowindow.h>

#include <mooscript/mooscript-context.h>
#include <mooscript/mooscript-func.h>
#include <mooscript/mooscript-node.h>
#include <mooscript/mooscript-parser.h>
#include <mooscript/mooscript-value.h>
#include <mooscript/mooscript-zenity.h>

#include <moofileview/moofileview.h>

#include <mooapp/mooapp.h>


#endif /* __MOO_H__ */
